package pl.edu.uw.heroes;

import pl.edu.uw.heroes.board.Board;
import pl.edu.uw.heroes.board.Position;
import pl.edu.uw.heroes.players.ExamplePlayer;
import pl.edu.uw.heroes.players.Player;
import pl.edu.uw.heroes.simulation.GameSimulation;
import pl.edu.uw.heroes.simulation.GameState;
import pl.edu.uw.heroes.units.ExampleUnit;
import pl.edu.uw.heroes.units.Unit;

public class Main {

    public static void main(String[] args) {
        Player playerLeft = new ExamplePlayer("Adam");
        Unit playerLeftUnit = new ExampleUnit(playerLeft, false, 4);
        playerLeft.getUnits().add(playerLeftUnit);

        Player playerRight = new ExamplePlayer("Wiktor");
        Unit playerRightUnit = new ExampleUnit(playerRight, true, 7);
        playerRight.getUnits().add(playerRightUnit);

        GameState gameState = new GameState(playerLeft, playerRight, new Board(10, 10));

        playerLeftUnit.doMove(gameState.getBoard().getField(new Position(0, 0)));
        playerRightUnit.doMove(gameState.getBoard().getField(new Position(2, 9)));

        GameSimulation gameSimulation = new GameSimulation(gameState);
        gameSimulation.printState();
        gameSimulation.executeOneAction();
        gameSimulation.printState();
        gameSimulation.executeOneAction();
        gameSimulation.printState();
        gameSimulation.executeOneAction();
        gameSimulation.printState();
    }
}
